﻿// ==UserScript==
// @name           GC Search geocache list
// @namespace      http://localhost
// @description    Pridanie zoznamu do search stranky a ikonky do mapy pre prepnutie na search stranku
// @include        https://www.geocaching.com/play/search*
// @include        https://www.geocaching.com/map*
// @include        http*://www.geocaching.com/seek/nearest.aspx*
// @version        0.0.2
// @grant          GM_getValue
// @grant          GM_setValue
// ==/UserScript==

var p_searchPageUrl = "https://www.geocaching.com/play/search/"; //url search stranky

var scrollIndex = 20;
var scrollIndexMaxValue = 20;
var zoznamKesiek = [];

var url = "" + window.location;


function caesar_vytvorDivPreZoznamAVypisZoznam(zmazButton){
	var zmazButton = zmazButton || false;

	if (!document.getElementById('caesar1987_cachelistDiv')){
		var elem = document.body;
			if (elem){
				//testovaci div aby sme vedeli ze prebehol reload
				var cachelistDiv = document.createElement("div");
				cachelistDiv.setAttribute('id','caesar1987_cachelistDiv');
				cachelistDiv.style.position = "fixed";
				cachelistDiv.style.width = "100px";
				cachelistDiv.style.height = "90%";
				cachelistDiv.style.top = "50px";
				cachelistDiv.style.right = "5px";
				cachelistDiv.style.fontSize = "11px";
				cachelistDiv.style.overflow = "scroll";
				cachelistDiv.style.backgroundColor="#FFFFCC";
				elem.appendChild(cachelistDiv);
				
		}
	}
	var elem2 = document.getElementById('caesar1987_cachelistDiv');
	elem2.innerHTML = "";
	
	var novybutton = document.createElement("input");
	novybutton.setAttribute('type','button');
	novybutton.setAttribute('value','Stiahnuť');
	//pridanie listenera na stlacenie buttonu
	novybutton.addEventListener('click', function(){
	
		caesar_vytvorSuborSoZoznamom();
		

	}, false);
	
	elem2.appendChild(novybutton);
	
	if (zmazButton == true){
		var novybuttonZmaz = document.createElement("input");
		novybuttonZmaz.setAttribute('type','button');
		novybuttonZmaz.setAttribute('value','Vymazať');
		//pridanie listenera na stlacenie buttonu
		novybuttonZmaz.addEventListener('click', function(){
			var potvrdenieZmazania = confirm("Naozaj chcete vymazať zoznam?");
			if (potvrdenieZmazania == true) {
				caesar_vymazZoznamZGMDatabazy();
				zoznamKesiek = [];
				caesar_vytvorDivPreZoznamAVypisZoznam(zmazButton);
			}

		}, false);
		
		elem2.appendChild(novybuttonZmaz);
	}
	
	var zoznamString = zoznamKesiek.join("\n");
	elem2.appendChild(document.createTextNode(zoznamString));

}

function caesar_searchPageScrollAction(){
	var keskyElementTmp = document.getElementsByClassName("cache-details");
	var keskaSplitTmp;
	for (var i = 0; i < keskyElementTmp.length;i++){
		keskaSplitTmp = keskyElementTmp[i].textContent.split(" | ");
		if (zoznamKesiek.indexOf(keskaSplitTmp[1].trim()) == -1){
			zoznamKesiek.push(keskaSplitTmp[1].trim());
		}
		
	}
	caesar_vytvorDivPreZoznamAVypisZoznam();
	
}

function caesar_vytvorSuborSoZoznamom(){ 
	obsah = zoznamKesiek.join("\r\n");
	caesar_vytvorSuborNaStiahnutie(obsah,"ZoznamKesiek");
}

function caesar_vytvorSuborNaStiahnutie(obsah,nazov){
	//vytvorenie pomocneho odkazu pre to, aby sme mohli dat suboru nazov a priponu. Bez neho to aktualne fo firefoxe nejde.
	var pomocnyOdkaz = document.createElement('a');
    pomocnyOdkaz.setAttribute('href', 'data:text/gpx;charset=utf-8,' + encodeURIComponent(obsah));
    pomocnyOdkaz.setAttribute('download', nazov+".ggt");
	pomocnyOdkaz.setAttribute('id', "caesar_pomocnyOdkaz");
	
	//pomocny odkaz umiestnime na stranku
	var element2 = document.body;
	element2.appendChild(pomocnyOdkaz);
	
	//klikneme na odkaz
	var theEvent = document.createEvent("MouseEvent");
	theEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
	var element = document.getElementById('caesar_pomocnyOdkaz');
	element.dispatchEvent(theEvent);
	
	//vymazeme odkaz
	element.parentNode.removeChild(element);

}

function caesar_presmerujNaVyhladavanie(){

	//ziskanie parametrov z url, upraveny kod z
	//http://stackoverflow.com/questions/5448545/how-to-retrieve-get-parameters-from-javascript/21210643#21210643
	var queryDict = {};
	window.location.hash.substr(2).split("&").forEach(function(item) {queryDict[item.split("=")[0]] = item.split("=")[1]});
	var vykladanaUrl = p_searchPageUrl + "@" + queryDict.ll + "?origin="+ queryDict.ll +"&radius=50km";
	
	var pomocnyOdkaz = document.createElement('a');
    pomocnyOdkaz.setAttribute('href', vykladanaUrl);
	pomocnyOdkaz.setAttribute('id', "caesar_pomocnyOdkaz2");
	pomocnyOdkaz.setAttribute('target', "_blank");
	var element2 = document.body;
	element2.appendChild(pomocnyOdkaz);
	
	//klikneme na odkaz
	var theEvent = document.createEvent("MouseEvent");
	theEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
	var element = document.getElementById('caesar_pomocnyOdkaz2');
	element.dispatchEvent(theEvent);
	
	//vymazeme odkaz
	element.parentNode.removeChild(element);
}

function mapPageAddLink(){
	var elem = document.getElementsByClassName("ProfileWidget")[0];
	if (elem){
	
		var novyodkazImg = document.createElement("img");
		novyodkazImg.setAttribute("src","/images/icons/search.png");
		novyodkazImg.setAttribute("id","caesar_mapaSearchImage");
		novyodkazImg.style.marginTop = "12px";
		
	
		var novyodkaz = document.createElement("a");
		novyodkaz.appendChild(novyodkazImg);
		novyodkaz.appendChild(document.createTextNode('Otvorit vyhladávanie'));
		novyodkaz.setAttribute("id","caesar_mapaSearch");
		novyodkaz.style.paddingRight = "20px";
		novyodkaz.style.cursor = "pointer";
		
		//pridanie listenera na stlacenie buttonu
		novyodkaz.addEventListener('click', function(){
		
			caesar_presmerujNaVyhladavanie();

		}, false);
	
		elem.insertBefore(novyodkaz, elem.firstChild);
	
	}else{
		console.warn("GC Pridanie nejakych ikoniek - nenasiel sa element, riadok:"+ new Error().lineNumber);
	}
}

function caesar_oldSearchPageScrollAction(){
	zoznamKesiek = GM_getValue("caesarZoznamKesiekString","").split(";"); //nacitanie zoznamu kesiek z databazy GM
	
	var tabulkaVysledkov = document.getElementsByClassName("SearchResultsTable");
	if (tabulkaVysledkov){
		var keskyElementTmp = tabulkaVysledkov[0].getElementsByClassName("lnk");
		var keskaSplitTmp;
		for (var i = 0; i < keskyElementTmp.length;i++){
			keskaSplitnuta = keskyElementTmp[i].getAttribute("href").split("geocache/")[1].split("_")[0];
			if (zoznamKesiek.indexOf(keskaSplitnuta.trim()) == -1){
				zoznamKesiek.push(keskaSplitnuta.trim());
			}
			
		}
	}
	
	caesar_vytvorDivPreZoznamAVypisZoznam(true);
	
	GM_setValue("caesarZoznamKesiekString", zoznamKesiek.join(";")); //ulozenie kesiek zo zoznamu do databazy GM

}

function caesar_vymazZoznamZGMDatabazy(){
	GM_setValue("caesarZoznamKesiekString", ""); //vymazanie vsetkych kesiek z databazy GM

}


/* scrollIndex */
function scrollIndexAdd(){
	scrollIndex++;
}
function returnScrollIndex(){
	return scrollIndex;
}

function scrollIndexReset(){
	scrollIndex = 0;
}


if (url.indexOf("play/search") != -1){ //otvorena search stranka

	window.addEventListener("scroll",  function () { 
							scrollIndexAdd();
							if (returnScrollIndex() >= scrollIndexMaxValue){
								setTimeout(function() {caesar_searchPageScrollAction();}, 0);
								scrollIndexReset();
								}
						}, false);
}else if (url.indexOf("map/") != -1){ //otvorena stranka s mapou
	mapPageAddLink();
}else if (url.indexOf("seek/nearest.aspx") != -1){ //otvorena stara search stranka
	window.addEventListener("scroll",  function () { 
							scrollIndexAdd();
							if (returnScrollIndex() >= scrollIndexMaxValue){
								setTimeout(function() {caesar_oldSearchPageScrollAction();}, 0);
								scrollIndexReset();
								}
						}, false);
}